# -*- coding: utf-8 -*-
from setuptools import setup

packages = \
['deutschland',
 'deutschland.jobsuche',
 'deutschland.jobsuche.api',
 'deutschland.jobsuche.apis',
 'deutschland.jobsuche.model',
 'deutschland.jobsuche.models']

package_data = \
{'': ['*']}

install_requires = \
['python-dateutil', 'urllib3>=1.25.3']

setup_kwargs = {
    'name': 'de-jobsuche',
    'version': '0.1.0',
    'description': 'Arbeitsagentur Jobsuche API',
    'long_description': '# jobsuche\nDie größte Stellendatenbank Deutschlands durchsuchen, Details zu Stellenanzeigen und Informationen über Arbeitgeber abrufen. <br><br> Die Authentifizierung funktioniert per OAuth 2 Client Credentials mit JWTs. Folgende Client-Credentials können dafür verwendet werden:<br><br> **ClientID:** c003a37f-024f-462a-b36d-b001be4cd24a <br> **ClientSecret:** 32a39620-32b3-4307-9aa1-511e3d7f48a8. **Achtung**: der OAuth header muss \'OAuthAccessToken\' heißen.<br><br> Die API verfügt außerdem nicht über ein gültiges TLS Zertifikat. Deswegen sollte die TLS-Validierung deaktiviert werden.\n\nThis Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:\n\n- API version: 2.0.0\n- Package version: 0.1.0\n- Build package: org.openapitools.codegen.languages.PythonClientCodegen\n\n## Requirements.\n\nPython >= 3.6\n\n## Installation & Usage\n### pip install\n\n```sh\npip install deutschland[jobsuche]\n```\n\n### poetry install\n\n```sh\npoetry add deutschland -E jobsuche\n```\n\n### Setuptools\n\nInstall via [Setuptools](http://pypi.python.org/pypi/setuptools).\n\n```sh\npython setup.py install --user\n```\n(or `sudo python setup.py install` to install the package for all users)\n\n## Usage\n\nImport the package:\n```python\nfrom deutschland import jobsuche\n```\n\n## Getting Started\n\nPlease follow the [installation procedure](#installation--usage) and then run the following:\n\n```python\n\nimport time\nfrom deutschland import jobsuche\nfrom pprint import pprint\nfrom deutschland.jobsuche.api import default_api\nfrom deutschland.jobsuche.model.job_application_details import JobApplicationDetails\nfrom deutschland.jobsuche.model.job_details import JobDetails\nfrom deutschland.jobsuche.model.job_search_response import JobSearchResponse\n# Defining the host is optional and defaults to https://rest.arbeitsagentur.de/jobboerse/jobsuche-service\n# See configuration.py for a list of all supported configuration parameters.\nconfiguration = jobsuche.Configuration(\n    host = "https://rest.arbeitsagentur.de/jobboerse/jobsuche-service"\n)\n\n# The client must configure the authentication and authorization parameters\n# in accordance with the API server security policy.\n# Examples for each auth method are provided below, use the example that\n# satisfies your auth use case.\n\n# Configure OAuth2 access token for authorization: clientCredAuth\nconfiguration = jobsuche.Configuration(\n    host = "https://rest.arbeitsagentur.de/jobboerse/jobsuche-service"\n)\nconfiguration.access_token = \'YOUR_ACCESS_TOKEN\'\n\n\n# Enter a context with an instance of the API client\nwith jobsuche.ApiClient(configuration) as api_client:\n    # Create an instance of the API class\n    api_instance = default_api.DefaultApi(api_client)\n    hash_id = "VK2qoXBe0s-UAdH_qxLDRrZrY5iY8a1PJt3MjJCXsdo=" # str | \n\n    try:\n        # Unternehmen Logo\n        api_response = api_instance.ed_v1_arbeitgeberlogo_hash_id_get(hash_id)\n        pprint(api_response)\n    except jobsuche.ApiException as e:\n        print("Exception when calling DefaultApi->ed_v1_arbeitgeberlogo_hash_id_get: %s\\n" % e)\n```\n\n## Documentation for API Endpoints\n\nAll URIs are relative to *https://rest.arbeitsagentur.de/jobboerse/jobsuche-service*\n\nClass | Method | HTTP request | Description\n------------ | ------------- | ------------- | -------------\n*DefaultApi* | [**ed_v1_arbeitgeberlogo_hash_id_get**](docs/DefaultApi.md#ed_v1_arbeitgeberlogo_hash_id_get) | **GET** /ed/v1/arbeitgeberlogo/{hashID} | Unternehmen Logo\n*DefaultApi* | [**pc_v2_app_jobs_hash_id_bewerbung_get**](docs/DefaultApi.md#pc_v2_app_jobs_hash_id_bewerbung_get) | **GET** /pc/v2/app/jobs/{hashID}/bewerbung | Bewerbung Kontaktdaten\n*DefaultApi* | [**pc_v2_jobdetails_hash_id_get**](docs/DefaultApi.md#pc_v2_jobdetails_hash_id_get) | **GET** /pc/v2/jobdetails/{hashID} | Jobdetail\n*DefaultApi* | [**pc_v4_app_jobs_get**](docs/DefaultApi.md#pc_v4_app_jobs_get) | **GET** /pc/v4/app/jobs | Jobsuche\n\n\n## Documentation For Models\n\n - [JobApplicationDetails](docs/JobApplicationDetails.md)\n - [JobApplicationDetailsAngebotskontakt](docs/JobApplicationDetailsAngebotskontakt.md)\n - [JobApplicationDetailsAngebotskontaktFestnetznummer](docs/JobApplicationDetailsAngebotskontaktFestnetznummer.md)\n - [JobApplicationDetailsAngebotskontaktMobilnummer](docs/JobApplicationDetailsAngebotskontaktMobilnummer.md)\n - [JobDetails](docs/JobDetails.md)\n - [JobDetailsArbeitgeberAdresse](docs/JobDetailsArbeitgeberAdresse.md)\n - [JobDetailsArbeitsorte](docs/JobDetailsArbeitsorte.md)\n - [JobDetailsAusbildungen](docs/JobDetailsAusbildungen.md)\n - [JobDetailsFertigkeiten](docs/JobDetailsFertigkeiten.md)\n - [JobDetailsFuehrungskompetenzen](docs/JobDetailsFuehrungskompetenzen.md)\n - [JobDetailsKoordinaten](docs/JobDetailsKoordinaten.md)\n - [JobDetailsLinks](docs/JobDetailsLinks.md)\n - [JobDetailsLinksArbeitgeberlogo](docs/JobDetailsLinksArbeitgeberlogo.md)\n - [JobDetailsLinksBewerbung](docs/JobDetailsLinksBewerbung.md)\n - [JobDetailsLinksDetails](docs/JobDetailsLinksDetails.md)\n - [JobDetailsLinksSelf](docs/JobDetailsLinksSelf.md)\n - [JobDetailsMobilitaet](docs/JobDetailsMobilitaet.md)\n - [JobDetailsSprachkenntnisse](docs/JobDetailsSprachkenntnisse.md)\n - [JobSearchResponse](docs/JobSearchResponse.md)\n - [JobSearchResponseAggregierungen](docs/JobSearchResponseAggregierungen.md)\n - [JobSearchResponseAggregierungenBundesland](docs/JobSearchResponseAggregierungenBundesland.md)\n - [JobSearchResponseAggregierungenPlzebene2](docs/JobSearchResponseAggregierungenPlzebene2.md)\n - [JobSearchResponseAuswahl](docs/JobSearchResponseAuswahl.md)\n - [JobSearchResponseEmbedded](docs/JobSearchResponseEmbedded.md)\n - [JobSearchResponseEmbeddedArbeitsort](docs/JobSearchResponseEmbeddedArbeitsort.md)\n - [JobSearchResponseEmbeddedArbeitsortKoordinaten](docs/JobSearchResponseEmbeddedArbeitsortKoordinaten.md)\n - [JobSearchResponseEmbeddedJobs](docs/JobSearchResponseEmbeddedJobs.md)\n - [JobSearchResponseEmbeddedLinks](docs/JobSearchResponseEmbeddedLinks.md)\n - [JobSearchResponseEmbeddedLinksArbeitgeberlogo](docs/JobSearchResponseEmbeddedLinksArbeitgeberlogo.md)\n - [JobSearchResponseEmbeddedLinksDetails](docs/JobSearchResponseEmbeddedLinksDetails.md)\n - [JobSearchResponseEmbeddedLinksJobdetails](docs/JobSearchResponseEmbeddedLinksJobdetails.md)\n - [JobSearchResponseFacetten](docs/JobSearchResponseFacetten.md)\n - [JobSearchResponseLinks](docs/JobSearchResponseLinks.md)\n - [JobSearchResponseLinksFirst](docs/JobSearchResponseLinksFirst.md)\n - [JobSearchResponseLinksLast](docs/JobSearchResponseLinksLast.md)\n - [JobSearchResponseLinksNext](docs/JobSearchResponseLinksNext.md)\n - [JobSearchResponseLinksSelf](docs/JobSearchResponseLinksSelf.md)\n - [JobSearchResponsePage](docs/JobSearchResponsePage.md)\n - [JobSearchResponseParserResult](docs/JobSearchResponseParserResult.md)\n - [JobSearchResponseParserResultKoordinaten](docs/JobSearchResponseParserResultKoordinaten.md)\n\n\n## Documentation For Authorization\n\n\n## clientCredAuth\n\n- **Type**: OAuth\n- **Flow**: application\n- **Authorization URL**: \n- **Scopes**: N/A\n\n\n## Author\n\nkontakt@bund.dev\n\n\n## Notes for Large OpenAPI documents\nIf the OpenAPI document is large, imports in jobsuche.apis and jobsuche.models may fail with a\nRecursionError indicating the maximum recursion limit has been exceeded. In that case, there are a couple of solutions:\n\nSolution 1:\nUse specific imports for apis and models like:\n- `from deutschland.jobsuche.api.default_api import DefaultApi`\n- `from deutschland.jobsuche.model.pet import Pet`\n\nSolution 2:\nBefore importing the package, adjust the maximum recursion limit as shown below:\n```\nimport sys\nsys.setrecursionlimit(1500)\nfrom deutschland import jobsuche\nfrom deutschland.jobsuche.apis import *\nfrom deutschland.jobsuche.models import *\n```\n\n',
    'author': 'BundesAPI',
    'author_email': 'kontakt@bund.dev',
    'maintainer': None,
    'maintainer_email': None,
    'url': 'https://github.com/bundesAPI/jobsuche-api',
    'packages': packages,
    'package_data': package_data,
    'install_requires': install_requires,
    'python_requires': '>=3.6',
}


setup(**setup_kwargs)
